/**
 * Copyright 2010 Västra Götalandsregionen
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of version 2.1 of the GNU Lesser General Public
 *   License as published by the Free Software Foundation.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *   Boston, MA 02111-1307  USA
 */

package se.vgregion.portal.admin.controller;

import se.vgregion.portal.cs.domain.SiteKey;
import se.vgregion.portal.cs.domain.UserSiteCredential;

import java.io.Serializable;

/**
 * Created by IntelliJ IDEA.
 * User: david
 * Date: 23/9-11
 * Time: 14:40
 */
public class CredentialSiteKeyFormBean implements Serializable {

    private static final long serialVersionUID = -2417191256232580482L;

    private UserSiteCredential credential;

    private SiteKey siteKey;

    public CredentialSiteKeyFormBean() {
    }

    public CredentialSiteKeyFormBean(UserSiteCredential credential, SiteKey siteKey) {
        this.credential = credential;
        this.siteKey = siteKey;
    }

    public UserSiteCredential getCredential() {
        return credential;
    }

    public void setCredential(UserSiteCredential credential) {
        this.credential = credential;
    }

    public SiteKey getSiteKey() {
        return siteKey;
    }

    public void setSiteKey(SiteKey siteKey) {
        this.siteKey = siteKey;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        CredentialSiteKeyFormBean that = (CredentialSiteKeyFormBean) o;

        if (credential != null ? !credential.equals(that.credential) : that.credential != null) return false;
        if (siteKey != null ? !siteKey.equals(that.siteKey) : that.siteKey != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = credential != null ? credential.hashCode() : 0;
        result = 31 * result + (siteKey != null ? siteKey.hashCode() : 0);
        return result;
    }
}
